<template>
  <div class=" columns">
    <div class="column is-4 is-offset-2">
      <b-field
        class="file is-fullwidth"
        :class="{'has-name': !!file, 'is-primary':!isUsingDemo}"
      >
        <b-upload
          v-model="file"
          class="file-label is-fullwidth"
          v-on:click="loadDemoData"
          type="is-light"
          rounded
          accept=".vtt"
        >
          <span class="file-cta">
            <b-icon class="file-icon" icon="cogs"></b-icon>
            <span class="file-label">{{
                (file && file.name) || "Analyze your meeting .vtt file"
              }}</span>
          </span>
        </b-upload>
      </b-field>
    </div>
    <div class="column is-4 is-offset-2">

      <b-field>
        <b-button
          :class="{'is-primary': isUsingDemo}"
          class="is-fullwidth"
          rounded
          v-on:click="loadDemoData"
        >Use a demo meeting
        </b-button>
      </b-field>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator';
import { Mutation } from 'vuex-class';
import example from './example-vtt';
import Gender from '@/models/gender';

@Component
export default class FileLoader extends Vue {
  file = null;

  isUsingDemo = false;

  @Watch('file')
  loadContentFromFile(file: any): void {
    if (file == null) {
      return;
    }
    this.$gtag.event('fileLoader', { method: 'loadContentFromFile' });

    this.isUsingDemo = false;
    const reader = new FileReader();

    reader.onload = (e) => {
      if (e) {
        this.$store.dispatch('loadVtt', e?.target?.result);
      }
    };
    reader.readAsText(file);
  }

  @Mutation('setTalkerGender')
  setTalkerGender!: (tg: { talkerName: string, gender: Gender }) => void;

  loadDemoData(): void {
    this.$gtag.event('fileLoader', { method: 'loadDemoData' });

    this.file = null;
    this.isUsingDemo = true;
    this.$store.dispatch('loadVtt', example);

    this.setTalkerGender({ talkerName: 'Bambi', gender: Gender.NON_BINARY });
    this.setTalkerGender({ talkerName: 'Daisy', gender: Gender.FEMALE });
    this.setTalkerGender({ talkerName: 'Donald', gender: Gender.MALE });
    this.setTalkerGender({ talkerName: 'Goofy', gender: Gender.MALE });
    this.setTalkerGender({ talkerName: 'Mickey', gender: Gender.MALE });
    this.setTalkerGender({ talkerName: 'Minnie', gender: Gender.FEMALE });
    this.setTalkerGender({ talkerName: 'Pluto', gender: Gender.MALE });
    this.setTalkerGender({ talkerName: 'Tinker Belle', gender: Gender.FEMALE });
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
h3 {
  margin: 40px 0 0;
}

ul {
  list-style-type: none;
  padding: 0;
}

li {
  display: inline-block;
  margin: 0 10px;
}

a {
  color: #42b983;
}

.file-cta {
  width: 100%;
}

</style>
